--- linux-2.6.27.6/include/asm-mips/i8259.h	2008-11-14 01:56:21.000000000 +0800
+++ linux-2.6.27.6.yaffs/include/asm-mips/i8259.h	2011-05-08 18:02:30.000000000 +0800
@@ -55,7 +55,10 @@
 
 	/* Perform an interrupt acknowledge cycle on controller 1. */
 	outb(0x0C, PIC_MASTER_CMD);		/* prepare for poll */
-	irq = inb(PIC_MASTER_CMD) & 7;
+	__asm__(".set noreorder; sb $0, 0x80(%0);.set reorder"::"r"(mips_io_port_base):"memory");
+	irq = inb(PIC_MASTER_CMD); 
+	printk("i8259_irq %x\n", irq);
+	irq = irq & 0x07;
 	if (irq == PIC_CASCADE_IR) {
 		/*
 		 * Interrupt is cascaded so perform interrupt
